UNIT Ugra;
{$G+}
INTERFACE

    TYPE  screentyp  = ARRAY[0..63999] OF byte;
          spriteType = RECORD
                         maske : pointer;
                         width,height   : Word;
                       END;

    VAR   screen   :^screentyp;
          spritez  : byte;
          sprite   : ARRAY[0..255] OF spriteType;
          palette  : ARRAY[0..770] OF byte;

    PROCEDURE gra_on;                                      {Initalisierung}
    PROCEDURE gra_off;                                     {Gibt belegten Speicher wieder frei u.a.}
    PROCEDURE pixel (x,y:Integer;B:Byte);                    {auf screen}
    PROCEDURE Load_scx (s:STRING;B:boolean);                 {64000 SCX auf $A000:0 ; B:palette}
    PROCEDURE Load_pal (s:STRING);                           {ld palette}
    PROCEDURE Set_pal;                                       {setzt palette}
    PROCEDURE SetPal(Col,R,G,B : Byte);
    PROCEDURE GetPal(Col : Byte; VAR R, G, B : Byte);
    PROCEDURE draw_all;                                      {Gibt Screen auf $a000:0 aus}
    PROCEDURE load_sprite (s:STRING);                        {ohne palette (.SCX) (reserviert Maske)}
    PROCEDURE blitsprite (x,y,SpriteNummer:Word);   {Malt auf screen eine Maske}
    PROCEDURE cls;                                           {clrscr}
    PROCEDURE WaitRetrace;                                   {Konstante Warteschleife}
    PROCEDURE Draw_Char( zeichen : char; x, y : integer; vg : byte );{Schreibt Zeichen}
    PROCEDURE Draw_String( x, y : integer; vg : byte; tstr : string );{Schreibt String}

    function Xkolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer): boolean; {prft ob kolision in 2D}
    function Ykolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer): boolean; {prft ob kolision in 2D}

    procedure blackP(x,y,xx,yy:word);
    function IntToStr(I: Longint): String;
    procedure rechteck(x,y,xx,yy:word;c:byte);
    procedure fillrechteck(x,y,xx,yy:word;c:byte);
    PROCEDURE Kreis (x,y:Integer;R,B:Byte);
    procedure Line( x1, y1, x2, y2, c : integer);
    procedure Line2(X1,Y1,X2,Y2,Color:integer);
    procedure dreieck(x1,y1,x2,y2,x3,y3:word;c:byte);
    PROCEDURE savescx (x,y,w,h:word;s:STRING);
    function  fpsec:real;

IMPLEMENTATION

USES dos;

PROCEDURE Kreis (x,y:Integer;R,B:Byte);
VAR I:Real;
    k:Word;
    xx,yy:integer;
BEGIN
   I:=0;
   FOR K:=1 TO Trunc(R*2*pi)+1 DO
   BEGIN
      I:=I+1/R;
      xx:=x+round(sin(I)*R);
      yy:=y+round(cos(I)*R);
      if (xx>0) and (xx<319) and (yy>0) and (yy<199) then Pixel(xx,yy,B);
   END;
END;

procedure Line2(X1,Y1,X2,Y2,Color:integer);
const
  MinX:integer=0;   MinY:integer=0;
  MaxX:integer=320; MaxY:integer=200;
var M,I,D,Dx,Dy,IncX,IncY,IncA,IncB:integer;
begin
  if ((Y1<MinY) and (Y2<MinY)) or ((Y1>MaxY) and (Y2>MaxY))
    or ((X1<MinX) and (X2<MinX)) or ((X1>MaxX) and (X2>MaxX)) then Exit;
  if X1<MinX then X1:=MinX; if X1>MaxX then X1:=MaxX;
  if X2<MinX then X2:=MinX; if X2>MaxX then X2:=MaxX;
  if Y1<MinY then Y1:=MinY; if Y1>MaxY then Y1:=MaxY;
  if Y2<MinY then Y2:=MinY; if Y2>MaxY then Y2:=MaxY;
  Dx:=Abs(X2-X1); Dy:=Abs(Y2-Y1);
  if Dx>=Dy then begin
    if X2>X1 then IncX:=1 else IncX:=-1;
    if Y2>Y1 then IncY:=320 else IncY:=-320;
  end else begin
    D:=Dx; Dx:=Dy; Dy:=D;
    if X2>X1 then IncY:=1 else IncY:=-1;
    if Y2>Y1 then IncX:=320 else IncX:=-320;
  end;
  D:=Dy shl 1-Dx; IncA:=D-Dx; IncB:=D+Dx;
  M:=320*Y1+X1;
  for I:=0 to Dx do begin
    pixel(y1,x1+m-(320*Y1+X1),color);
{    Mem[$A000:M]:=Color;}
    Inc(M,IncX);
    if D>=0 then begin Inc(D,IncA); Inc(M,IncY); end
      else Inc(D,IncB);
  end;
end;

procedure Line( x1, y1, x2, y2, c : integer);
var d, dx, dy,
    aincr, bincr,
    xincr, yincr,
    x, y          : integer;

procedure SwapInt( var i1, i2: integer );
var dummy : integer;
begin
  dummy := i2;
  i2    := i1;
  i1    := dummy;
end;

begin
  if ( abs(x2-x1) < abs(y2-y1) ) then   { ber X- oder Y-Achse laufen? }
    begin                                           { ber die Y-Achse }
      if ( y1 > y2 ) then                              { y1 grer y2? }
        begin
          SwapInt( x1, x2 );                   { Ja, X1 mit X2 und     }
          SwapInt( y1, y2 );                   { Y1 mit Y2 vertauschen }
        end;
      if ( x2 > x1 ) then xincr := 1      { Spalteninkrement festlegen }
                     else xincr := -1;
      dy := y2 - y1;
      dx := abs( x2-x1 );
      d  := 2 * dx - dy;
      aincr := 2 * (dx - dy);
      bincr := 2 * dx;
      x := x1;
      y := y1;
      pixel ( x, y, c );                     { ersten Punkt setzen }
      for y:=y1+1 to y2 do              { Line auf X-Achse durchlaufen }
        begin
          if ( d >= 0 ) then
            begin
              inc( x, xincr );
              inc( d, aincr );
            end
          else
            inc( d, bincr );
          pixel ( x, y, c );
        end;
    end
  else                                              { ber die X-Achse }
    begin
      if ( x1 > x2 ) then                              { x1 grer x2? }
        begin
          SwapInt( x1, x2 );                   { Ja, X1 mit X2 und     }
          SwapInt( y1, y2 );                   { Y1 mit Y2 vertauschen }
        end;
      if ( y2 > y1 ) then yincr := 1       { Zeileninkrement festlegen }
                     else yincr := -1;
      dx := x2 - x1;
      dy := abs( y2-y1 );
      d  := 2 * dy - dx;
      aincr := 2 * (dy - dx);
      bincr := 2 * dy;
      x := x1;
      y := y1;
      pixel ( x, y, c );                     { ersten Punkt setzen }
      for x:=x1+1 to x2 do              { Line auf X-Achse durchlaufen }
        begin
          if ( d >= 0 ) then
            begin
              inc( y, yincr );
              inc( d, aincr );
            end
          else
            inc( d, bincr );
          pixel( x, y, c );
       end;
    end;
end;

procedure dreieck(x1,y1,x2,y2,x3,y3:word;c:byte);
begin
 line(x1,y1,x2,y2,c);
 line(x2,y2,x3,y3,c);
 line(x3,y3,x1,y1,c);
end;


procedure rechteck(x,y,xx,yy:word;c:byte);
var ix,iy:word;
begin
 if xx>x then for ix:=x to xx do pixel(ix,y,c)
  else for ix:=x downto xx do pixel(ix,y,c);
 if yy>y then for iy:=y to yy do pixel(x,iy,c)
  else for iy:=y downto yy do pixel(x,iy,c);
 if xx>x then for ix:=x to xx do pixel(ix,yy,c)
  else for ix:=x downto xx do pixel(ix,yy,c);
 if yy>y then for iy:=y to yy do pixel(xx,iy,c)
  else for iy:=y downto yy do pixel(xx,iy,c);
end;

procedure fillrechteck(x,y,xx,yy:word;c:byte);
var ix,iy:word;
begin
 if xx>x then for ix:=x to xx do
   if yy>y then for iy:=y to yy do pixel(ix,iy,c)
     else for iy:=y downto yy do pixel(ix,iy,c)
 else for ix:=x downto xx do
   if yy>y then for iy:=y to yy do pixel(ix,iy,c)
     else for iy:=y downto yy do pixel(ix,iy,c);
end;

PROCEDURE savescx (x,y,w,h:word;s:STRING);
TYPE ktyp=ARRAY[1..4] OF byte;
CONST ckopf:ktyp=(82,73,88,51);
VAR f:FILE;
    k,ix,iy:word;
    C:byte;
BEGIN
   k:=175;
   inc(w);
   inc(h);
   assign (f,s);
   rewrite (f,1);
   blockwrite (f,ckopf,4);
   blockwrite (f,w,2);
   blockwrite (f,h,2);
   blockwrite (f,k,2);
   blockwrite (f,palette,768);
   for iy:=y to (y+h) do
    for ix:=x to (x+w)-1 do
    begin
     c:=mem[$A000:iy*320+ix];
     blockwrite(f,c,1);
    end;
   close (f);
END;

const n=19;
var  dif:array[0..n]of integer;

function fpsec:real;
const h:word=0;
      m:word=0;
      s:word=0;
      hun:word=0;
      hun2:word=0;
      hu:integer=0;
      hu2:integer=0;
      b:boolean=true;
      i:integer=0;
      mit:real=0;
begin
 b:=not b;
 if b then
   begin
    gettime(h,m,s,hun);
    hu:=hun;
    if hu<hu2 then dec(hu2,100);
    dif[i]:=hu-hu2;
   end
  else
   begin
    gettime(h,m,s,hun2);
    hu2:=hun2;
    if hu2<hu then dec(hu,100);
    dif[i]:=hu2-hu
   end;
 inc(i);
 if i=n+1 then
  begin
   mit:=0;
   for i:=n downto 0 do
    mit:=mit+dif[i];
   mit:=100/(mit/n+1);
  end;
 fpsec:=mit;
end;

PROCEDURE Draw_Char( zeichen : char; x, y : integer; vg : byte );
TYPE ZDEF = ARRAY[0..255,0..7] OF byte;
     ZPTR = ^ZDEF;
VAR  regs : registers;
     ch    : char;
     i, k,
     Maske : byte;
CONST fptr : ZPTR = NIL;
BEGIN
  IF fptr = NIL THEN
    BEGIN
      Regs.AH := $11;
      Regs.AL := $30;
      Regs.BH := 3;
      intr( $10, Regs );
      fptr := ptr( Regs.ES, Regs.BP );
    END;
    FOR i := 0 TO 7 DO
      BEGIN
        Maske := fptr^[ord(zeichen),i];
        FOR k := 0 TO 7 DO
          BEGIN
            IF ( Maske AND 128 <> 0 ) THEN
              pixel( x+k, y+i, vg );
            Maske := Maske SHL 1;
          END;
      END
END;

PROCEDURE Draw_String( x, y : integer; vg : byte; tstr : string );
VAR i : integer;
BEGIN
  FOR i := 1 TO length( tstr ) DO
    BEGIN
      Draw_Char( tstr[i], x, y, vg );
      inc( x, 8 );
    END;
END;

PROCEDURE cls;ASSEMBLER;
   ASM
      les di,screen
      mov cx,16000
      xor di,di
      xor bx,bx
      mov al,bl
      mov ah,bl
      db $66; SHL ax,16
      mov al,bl
      mov ah,bl
      db $66; rep stosw
   END;

PROCEDURE GetPal(Col : Byte; VAR R, G, B : Byte);
BEGIN
   port[$3c7]:=col;
   r:=port[$3c9];
   g:=port[$3c9];
   b:=port[$3c9];
END;

PROCEDURE SetPal(Col,R,G,B : Byte); ASSEMBLER;
ASM
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
END;

PROCEDURE WaitRetrace;
ASSEMBLER;
  ASM
    mov dx,$3da
  @1:
    IN al,dx
    test al,8
    jz @1
  @2:
    IN al,dx
    test al,8
    jnz @2
  END;

PROCEDURE pixel (x,y:Integer;B:Byte);assembler;
{begin
if (x>0) and (x<320) and (y>0) and (y<200) then}
ASM
   mov ax,y
   mov bx,ax
   SHL ax,8
   SHL bx,6
   add bx,ax
   add bx,x
   mov cl,b
   les di,screen
   mov [es:bx+di],cl
END;
{end;}

PROCEDURE load_pal (s:STRING);
VAR f:FILE;
BEGIN
   assign (f,s);
   reset (f,1);
   blockread (f,palette,768);
   close (f);
END;

PROCEDURE set_pal;
VAR k:word;
BEGIN
   port[$3c8]:=0;
   FOR k:=0 TO 767 DO port[$3c9]:=palette[k];
END;

PROCEDURE Load_scx (s:STRING;B:boolean);
VAR f:FILE;
    k:word;
BEGIN
   assign (f,s);
   reset (f,1);
   seek (f,10);
   blockread (f,palette,768);
   port[$3c8]:=0;
   IF b THEN FOR k:=0 TO 767 DO port[$3c9]:=palette[k];
   blockread (f,mem[$A000:0],64000);
   close (f);
END;

PROCEDURE load_sprite (s:STRING);
VAR f:FILE;
BEGIN
   WITH sprite[spriteZ] DO
   BEGIN
     assign (f,s);
     reset (f,1);
     seek (f,4);
     blockread (f,width,2);
     blockread (f,height,2);
     seek (f,778);
     getmem (maske,width*height);
     blockread (f,maske^,width*height);
     close (f);
     inc (spritez);
   END;
END;

PROCEDURE blitsprite (x,y,SpriteNummer:Word);
VAR
  pc,ad   : Word;
  spritep : Pointer;
  w,h     : Integer;

BEGIN
  WITH Sprite[SpriteNummer] DO
  BEGIN
    w := width;
    h := height;
    spritep := maske;
  END;

ASM
   push ds
   les di,screen
   lds si,spritep
   mov ax,y

   mov dx,h
   cmp ax,199
   jg @ende
   mov cx,h
   neg cx
   inc cx
   cmp ax,cx
   jl @ende
   mov cx,200
   sub cx,h
   cmp ax,cx
   jl @ylowclip
   mov dx,200
   sub dx,ax
   jmp @endclipy
@ylowclip:
   cmp ax,0
   jnl @endclipy
   add dx,ax
   sal ax,5
   sub si,ax
   xor ax,ax
@endclipy:
   mov bx,ax
   SHL ax,8
   SHL bx,6
   add di,ax
   add di,bx
   mov ax,w
   mov pc,ax
   mov bx,x

   mov cx,w
   neg cx
   inc cx
   cmp bx,cx
   jl @ende
   cmp bx,319
   jg @ende
   mov cx,320
   sub cx,w
   cmp bx,cx
   jna @endxclip
   jng @xlowclip
   mov ax,320
   sub ax,bx
   mov pc,ax
   jmp @endxclip
@xlowclip:
   cmp bx,0
   jge @endxclip
   sub si,bx
   add pc,bx
   xor bx,bx
@endxclip:
   add di,bx
   mov ax,w
   sub ax,pc
   mov bx,ax
@yloop:
   mov cx,pc
@xloop:
   mov al,[si]
   inc si
   OR al,al
   jz @weiter
   mov [es:di],al
@weiter:
   inc di
   dec cx
   jnz @xloop
   add di,320
   sub di,w
   add si,bx
   add di,bx
   dec dx
   jnz @yloop
@ende:
   pop ds
END;
END;

PROCEDURE draw_all; ASSEMBLER;
   ASM
      push ds
      mov ax,$a000
      mov es,ax
      xor di,di
      lds si,screen
      mov cx,16000
      db $66; rep movsw
      pop ds
   END;

PROCEDURE gra_on;
BEGIN
  ASM
    mov ax,13h
    int 10h
  END;
  getmem (screen,64000);
  fillchar (screen^,64000,0);
  spritez:=0;
END;

PROCEDURE gra_off;
VAR k:byte;
BEGIN
  freemem (screen,64000);
  FOR k:=0 TO Spritez DO WITH Sprite[k] DO freemem(maske,width*height);
  ASM
    mov ax,3h
    int 10h
  END;
END;

function XKolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer):boolean;
begin
 if (kx+k_x>=bx ) and (kx<bx+b_x) and
    (ky+k_y-2>by) and (ky+2<=by+b_y)
       then xkolision:=true
       else xkolision:=false
end;

function YKolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer):boolean;
begin
 if (ky+k_y>=by ) and (ky<by+b_y) and
    (kx+k_x-2>bx) and (kx+2<=bx+b_x)
       then ykolision:=true
       else ykolision:=false
end;

procedure blackp(x,y,xx,yy:word);
var ix,iy:word;
begin
 for ix:=x to xx do
  for iy:=y to yy do
   pixel(ix,iy,0);
end;

function IntToStr(I: Longint): String;
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

END.